<template>
  <div id="app">
    <cv-header aria-label="Link Budget Playground Team Name">
      <cv-skip-to-content href="#main-content">
        Skip to content
      </cv-skip-to-content>
      <cv-header-name
        href="javascript:void(0)"
        prefix="Link Budget Playground"
      >
        Team Name
      </cv-header-name>
      <template slot="header-global">
        <cv-header-global-action
          title="Reset view"
          @click="actionReset"
        >
          <ZoomReset20 />
        </cv-header-global-action>
        <cv-header-global-action
          title="Low quality"
          aria-controls="user-panel"
          :class="{
            'bx--header--active' : lowQuality
          }"
          @click="actionLowQuality"
        >
          <ViewOff20 />
        </cv-header-global-action>
        <cv-header-global-action
          title="About"
          aria-controls="about-modal"
          @click="actionAbout"
        >
          <Information20 />
        </cv-header-global-action>
        <cv-header-nav>
          <cv-header-menu-item
            href="https://gitlab.com/acubesat/education/link-budget-playground"
            title="App version"
          >
            {{ version }}
          </cv-header-menu-item>
          <cv-header-menu-item title="Current time">
            {{ timestamp }}
          </cv-header-menu-item>
        </cv-header-nav>
      </template>
    </cv-header>
    <main
      id="#main-content"
      class="bx--content"
    >
      <earth
        ref="earth"
        class="earth"
      />
      <div class="bx--grid bx--grid--full-width bx--row landing-page">
        <div class="bx--col-md-4 bx--col-lg-4 column-grid">
          <div class="column-grid-column">
            <div class="card card-fill">
              <h2 class="card-title">
                Card title
              </h2>
              <div class="card-content">
                Card errors
              </div>
            </div>
          </div>
          <div class="column-grid-column">
            <div class="card card-fill">
              <h2 class="card-title">
                Cost Budget
              </h2>
              <div class="card-content">
                <CostCard />
              </div>
            </div>
          </div>
        </div>
        <div
          class="bx--col-md-4 bx--col-lg-4 bx--offset-lg-4 column-grid"
        >
          <div class="column-grid-column">
            <div class="card card-fill">
              <h2 class="card-title">
                Communication parameters
              </h2>
              <div class="card-content">
                <ParameterCard />
              </div>
            </div>
          </div>
        </div>
      </div>
    </main>
    <about
      id="about-modal"
      ref="about"
    />
  </div>
</template>

<style lang="scss">
.bx--header {
  white-space: pre-wrap;
}

.bx--content {
  height: calc(100vh - 3rem);
}

.landing-page {
  height: 100%;
  align-items: stretch;
}

.earth {
  position: absolute;
  top: 0;
  left: 0;

  width: calc(100%);
  height: calc(100%);

  overflow: hidden;

  z-index: -1;
}
</style>

<script>
import ViewOff20 from "@carbon/icons-vue/es/view--off/20";
import Information20 from "@carbon/icons-vue/es/information/20";
import ZoomReset20 from "@carbon/icons-vue/es/zoom--reset/20";
import "./styles/_carbon.scss";
import "./styles/_column-grid.scss";
import "./styles/_card.scss";
import "./styles/_header.scss";
import Earth from "./components/Earth.vue";
import About from "./components/About.vue";
import ParameterCard from "./components/ParameterCard.vue";
import CostCard from "./components/CostCard.vue";

var timeInterval;

export default {
  name: "App",
  components: {
    Earth,
    About,
    ParameterCard,
    CostCard,
    ViewOff20,
    Information20,
    ZoomReset20
  },
  data() {
    return {
      teamName: "ToastMakers",
      lowQuality: 0,
      version: process.env.VUE_APP_GIT_VERSION,
      timestamp: ""
    };
  },
  created() {
      timeInterval = setInterval(this.getNow, 1000);
  },
  beforeDestroy() {
      clearInterval(timeInterval);
  },
  mounted() {
    this.$nextTick(function() {
      if (localStorage.lowQuality && localStorage.lowQuality === "true") {
        this.actionLowQuality();
      }
    });
  },
  methods: {
    actionAbout: function() {
      this.$refs.about.show();
    },
    actionReset: function() {
      this.$refs.earth.reset();
    },
    actionLowQuality: function() {
      if (this.$data.lowQuality) {
        this.$refs.earth.setQuality(1);
      } else {
        this.$refs.earth.setQuality(0.5);
      }

      this.$data.lowQuality = !this.$data.lowQuality;
      localStorage.lowQuality = this.$data.lowQuality;
    },
    getNow: function() {
        const today = new Date();
        this.timestamp = today.toLocaleString('el-GR-u-ca-iso8601-hc-h23');
    }
  }
};
</script>

<style lang="scss">
.landing-page {
  // Making the landing page hidden allows clicking the earth under it
  visibility: hidden;
}

.landing-page > * {
  // ...however the components have to be visible to the user
  visibility: visible;
}
</style>
